/*****************************************************************************

		Copyright (c) 1984 - 2000 Prolog Development Center A/S

 Project:  SEN_AN
 FileName: SEN_AN.PRO
 Purpose: No description
 Written by: Visual Prolog
 Comments:
******************************************************************************/


						%com.:!!!"  ":   !!!
						%com.: ,  "com.:",    
						%com.:     , ..     
						%com.:        ,   
						%com.:    goal.

facts - senan_db 				%com.:        ()
  det(string)
  noun(string)
  rel(string)
  verb(string)

domains						%com.:  
  DETERM	= none;
  		  determ(string)
  NOUNP		= nounp(DETERM,string,RELCL)
  RELCL		= none;
  		  relcl(string,VERBP)
  SENTENCE	= sent(NOUNP,VERBP)
  VERBP		=verb(string);
		  verbp(string,NOUNP)
  TOKL		= string*			%com.:  

predicates					%com.: "" 
% Recognition of words in different forms
  is_det(string)
  is_noun(string)
  is_rel(string)
  is_verb(string)
  
  is_verbs(string)			%my
  is_verbed(string)
  is_nounl(string)

% Parser
  nondeterm s_determ(TOKL,TOKL,DETERM)
  nondeterm s_nounp(TOKL,TOKL,NOUNP)
  nondeterm s_relcl(TOKL,TOKL,RELCL)
  nondeterm s_sentence(TOKL,TOKL,SENTENCE)
  nondeterm s_verbp(TOKL,TOKL,VERBP)

% scanner
  check(string)
  tokl(string,TOKL)

clauses						%com.:  
						/*com.:   s_*,      .
							         ,   
							  .    -     , 
							-   (,  ).
							        .  
							 :  ,      
							 (  ),  ;    -  . 
							      ,  
							     ,    
							  ,   -  , .. ,     
							.       ,     
							  :   .  */
						


  s_sentence(TOKL,TOKL2,sent(NOUNP,VERBP)):- 	%com.: :    ,  
	s_nounp(TOKL,TOKL1,NOUNP),		%com.:     , 	
	s_verbp(TOKL1,TOKL2,VERBP),		%com.:    -  ,  
	TOKL2=[],				%com.:     ( ).
	!.					%com.: :  ,      . 
  s_sentence(_,_,_):-
	write(">> Sentence not recognized\n"),	%com.:    , ,   .
	fail.

  s_nounp(TOKL,TOKL2,nounp(DETERM,NOUN,RELCL)):-%com.:   -   
	s_determ(TOKL,[NOUN|TOKL1],DETERM),	%com.:  (  ),  
	is_noun(NOUN),				%com.: ,    
	s_relcl(TOKL1,TOKL2,RELCL).		%com.:   ( ).
s_nounp(TOKL,TOKL2,nounp(DETERM,NOUN,RELCL)):-%com.:   -   
	s_determ(TOKL,[NOUN|TOKL1],DETERM),	%com.:  (  ),  
	is_nounl(NOUN),				%com.: ,    
	s_relcl(TOKL1,TOKL2,RELCL).		%com.:   ( ).

  s_determ([DETERM|TOKL],TOKL,determ(DETERM)):- %com.: :     
	is_det(DETERM).				%com.: .
  s_determ(TOKL,TOKL,none).			%com.:  -  ,     .

  s_relcl([REL|TOKL],TOKL1,relcl(REL,VERBP)):-	%com.:  :    
	is_rel(REL),				%com.: ,     	
	s_verbp(TOKL,TOKL1,VERBP).		%com.:  .	
  s_relcl(TOKL,TOKL,none).			%com.:         , , 
  						%com.:  ,   .

  s_verbp([VERB|TOKL],TOKL1,verbp(VERB,NOUNP)):-%com.:  :    
	is_verb(VERB),				%com.: ,   
	s_nounp(TOKL,TOKL1,NOUNP).		%com.:  .
  s_verbp([VERB|TOKL],TOKL,verb(VERB)):-	%com.: ,      
	is_verb(VERB).				%com.: .
  s_verbp([VERB|TOKL],TOKL,verb(VERB)):-	%com.: ,      
	is_verbs(VERB).	
  s_verbp([VERB|TOKL],TOKL,verb(VERB)):-	%com.: ,      
	is_verbed(VERB).	
	
  is_noun(X):-				/*com.:  ,     -  */						
	noun(X),			/*com.: , "-,     ,   - "*/
	!.				/*com.: :       ,   */
  is_noun(X):-				/*com.:     */
	noun(Y),			/*com.: " "X"="Y"+"s" - ,  Y - */
	concat(Y,"s",X),
	!.



  is_det(X):-				/*com.: */
	det(X),
	!.

  is_rel(X):-				/*com.:*/
	rel(X),
	!.

  is_verb(X):-				/*com.: */
	verb(X),
	!.
 
  is_verb(X):-
	verb(Y),
	concat(Y,"ing",X),
	!.

  is_verbs(X):-				/*com.:,   */
	verb(Y),
	concat(Y,"s",X),
	!.

  is_verbs(X):-
	verb(Y),
	concat(Y,"es",X),
	!.
  is_verbed(X):-
	verb(Y),
	concat(Y,"ed",X),
	!.
  is_verbed(X):-
	verb(Y),
	concat(Y,"d",X),
	!.

 is_nounl(X):-				/*com.:     */
	noun(Y),			/*com.: " "X"="Y"+"s" - ,  Y - */
	concat(Y,"_ll",X),
	!.
	
  tokl(STR,[TOK|TOKL]):-		/*com.: ,     (list -  ) .
  						 :  ,     
  						  ,      .
  						      .  :
  						  ,     ,
  						      ( ).
  					*/
	fronttoken(STR,TOK,STR1),	/*com.:   fronttoken (STRING String, STRING Token, STRING RestString)
						    String,   - Token,   RestString*/
	
	
	check(TOK),			/*com.: ,     */
	!,				/*com.: :        ,
						 -     */
	tokl(STR1,TOKL).		/*com.:   */
  tokl(_,[]).				/*com.:   */

  
  
  
  check(WORD):-				/*com.:  ,      ,  */
	is_noun(WORD),
	!.				/*com.::  ,    ,   ,  */
  check(WORD):-
	is_det(WORD),
	!.
  check(WORD):-
	is_rel(WORD),
  	!.
  	
  check(WORD):-
	is_verb(WORD),
	write ("Action in curent time\n"),
	!.
  	
  check(WORD):-
	is_verbs(WORD),
	write ("Action in curent time\n"),
	!.
	
   check(WORD):-
	is_verbed(WORD),
	write ("Action in past\n"),
	!.
	
    check(WORD):-
	is_nounl(WORD),
	write ("Action in future\n"),
	!.
	
  check(WORD):-				/*com.:      , ,   */
	write(">> Unknown word: ",WORD),
	nl.

goal	%com.:  Goal   ,   -    .   .
  consult("sen_an.dba",senan_db),			%com.:  ,  .
  write("Try: every man that lives loves a woman\n"),	%com.:    .
  write("Write a sentence: "),				%com.:     .
  readln(STR),						%com.:  .
  tokl(STR,TOKL),					%com.:      .
  s_sentence(TOKL,RESTTOKL,SENT),			%com.:  .
  RESTTOKL=[].						%com.:        
  %write(SENT).  						%com.:  .
